%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% @doc restapi monitor metrics list
%%% @end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%_* Module declaration ===============================================
-module(restapi_monitor_metrics_list).

%%%_* Behaviour ========================================================
-behaviour(cowboy_http_handler).

%%%_* Exports ==========================================================
-export([ init/3
        , handle/2
        , terminate/3
        ]).

%%%_* API ==============================================================
init({_Any, http}, Req, []) -> {ok, Req, undefined}.

handle(Req, State) ->
  Metrics =
    case cowboy_req:qs_val(<<"info">>, Req, undefined) of
      {<<"true">>, _Req} -> folsom_metrics:get_metrics_info();
      {_, _Req}          -> folsom_metrics:get_metrics()
    end,
  Headers =
    [ {<<"content-type">>, <<"application/json; charset=utf-8">>}
    ],
  {ok, Reply} =
    cowboy_req:reply(200, Headers, restapi_json:encode(Metrics), Req),
  {ok, Reply, State}.

terminate(_Reason, _Req, _State) -> ok.

%%%_* Emacs ============================================================
%%% Local Variables:
%%% allout-layout: t
%%% erlang-indent-level: 2
%%% End:
