%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% @doc restapi monitor process
%%% @end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%_* Module declaration ===============================================
-module(restapi_monitor_process).

%%%_* Behaviour ========================================================
-behaviour(cowboy_http_handler).

%%%_* Exports ==========================================================
-export([ init/3
        , handle/2
        , terminate/3
        ]).

%%%_* API ==============================================================
init({_Any, http}, Req, []) -> {ok, Req, undefined}.

handle(Req, State) ->
  JSON    = restapi_json:encode(folsom_vm_metrics:get_process_info()),
  Headers =
    [ {<<"content-type">>, <<"application/json; charset=utf-8">>}
    ],
  {ok, Reply} = cowboy_req:reply(200, Headers, JSON, Req),
  {ok, Reply, State}.

terminate(_Reason, _Req, _State) -> ok.

%%%_* Emacs ============================================================
%%% Local Variables:
%%% allout-layout: t
%%% erlang-indent-level: 2
%%% End:
